<?php

/**

Plugin Name: matriphe! KeyCode
Version: 1.00
Plugin URI: http://blog.matriphe.com/index.php/2006/09/19/matriphe-keycode/
Description: Against spammer using human friendly plain-text keycode. Based on <a href="http://www.elzan.com/tesign/2006/07/17/comment-keycode-anti-spam/" target="_blank">Comment KeyCode</a> by <a href="http;//www.elzan.com/" target="_blank">Elzan Yahya</a>.
Author: Muhammad Zamroni
Author URI: http://blog.matriphe.com/

modifi pour la version K2 / VF par Alba
*/


//-- CONFIGURATIONS

 $autoKeycodeForm = false;	// set it into 'false' if you use manual copy html from README.txt file!
 $default_words = "kambing sapi ayam babi badak kudanil kuda kecoa gajah penyu kalkun burung kadal monyet kodok kucing anjing tikus bebek siput ular naga ikan banteng domba";
 $user_words = "kancil bekicot buaya";
 $autoload = "yes";
 $auto_option = "default";
 $auto_key = "matriphe_key";
 $description = "";

 add_option("matriphe_keycode_option", $auto_option, $description, $autoload);
 add_option("matriphe_keycode_key", $auto_key, $description, $autoload);
 add_option("matriphe_keycode_default_words", $default_words, $description, $autoload);
 add_option("matriphe_keycode_user_words", $user_words, $description, $autoload);


//-- UPDATE THE SETTINGS
if (isset($_POST['mtp_update_option'])) {
	$keycode_options = $_POST['keycode_options'];
	$keycode_key = trim($_POST['keycode_key']);
	$user_keywords = trim($_POST['user_keywords']);

	if ($keycode_key != "") {
		update_option("matriphe_keycode_key", $keycode_key);
	}

	if ($user_keywords != "") {
		update_option("matriphe_keycode_user_words", $user_keywords);
	}

	update_option("matriphe_keycode_option", $keycode_options);
	$updated = true;
}


//-- ADMIN MENU
add_action('admin_menu', 'mtp_keycode_config_page');

function mtp_keycode_config_page() {
	global $wpdb;
	if ( function_exists('add_submenu_page') )
		add_submenu_page('plugins.php', __('KeyCode Settings'), __('KeyCode Settings'), 'manage_options', __FILE__, 'mtp_conf');
}

function mtp_conf() {
	global $updated;

	if ($updated == true) {	echo "<div id=\"message\" class=\"updated fade\"><p><strong>Settings saved.</strong></p></div>"; }
	$updated = false;
?>

<div class="wrap">
	<form action="" method="post" id="mtp-keycode-conf">
	<h2><?php _e('KeyCode Settings'); ?></h2>
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
	<tr valign="top">
	<th width="25%" scope="row">Keycode Option</th>
	<td>
	<select name="keycode_options" id="keycode_option">
	<?php
	$mtp_option = array('default' => 'Default Keywords', 'user' => 'User Specified Keywords', 'both' => 'Both User and Default Keywords', 'random' => 'System Generate Random Kewords');
	reset($mtp_option);
	while (list($key, $val) = each($mtp_option)) {
		if ($key == get_option('matriphe_keycode_option')) { $selected = "selected='selected'"; } else { $selected = ""; }

		print "<option value='".$key."' ".$selected.">".$val."</option>\n";
	}
	?>
	</select>
	<p>You can choose what random keywords will be shown. Use default if you want to use the plugin's default keywords, your specified keywords, both default and your specified words, or system generated random words.</p>
	</td>
	</tr>
	<tr valign="top">
	<th width="25%" scope="row">Keycode Key</th>
	<td>
	<input name="keycode_key" type="text" id="keycode_key" value="<?php print get_option('matriphe_keycode_key') ?>" size="40" />
	<p>This word is used for encryption key. It's sugested to use your own words as a key.</p>
	</td>
	</tr>
	</table>
	<h2><?php _e('KeyCode Words'); ?></h2>
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
	<tr valign="top">
	<th width="25%" scope="row">Default Keywords</th>
	<td>
	<p style="margin: 0; padding: 3px; border: 1px #777 solid; width: 98%"><code><?php print get_option('matriphe_keycode_default_words') ?></code></p>
	</td>
	</tr>
	<tr valign="top">
	<th width="25%" scope="row">User Specified Keywords</th>
	<td>
	<textarea name="user_keywords" id="user_keywords" style="width: 98%;" rows="3" cols="50"><?php print get_option('matriphe_keycode_user_words') ?></textarea>
	<p>Separate multiple words with spaces.</p>
	</td>
	</tr>
	</table>
	<p class="submit">
	<input type="submit" style="font-weight: bold" name="Submit" value="Save Settings" />
	<input type="hidden" name="mtp_update_option" />
	</p>
	</form>
</div>
<?php
}


//-- THE MAIN KEYCODE

 $keycodeDefaultWords = get_option('matriphe_keycode_default_words');
 $keycodeUserWords = get_option('matriphe_keycode_user_words');
 $keycodeKey = get_option('matriphe_keycode_key');
 $keycodeOption = get_option('matriphe_keycode_option');

 $defaultKeyWords = explode(" ", $keycodeDefaultWords);
 $userKeyWords = explode(" ", $keycodeUserWords);

 $theKeyWords = array_merge($defaultKeyWords, $userKeyWords);


function matriphe_get_keycode() {
	global $keycodeOption, $theKeyWords, $userKeyWords, $defaultKeyWords;

	switch ($keycodeOption) {
		case "random":
			srand ((float) microtime() * 10000000);
			$keycodeStr = substr(md5(uniqid(microtime())),0,5);
		break;
		case "both":
			$randnum = rand(0,count($theKeyWords)-1);
			$keycodeStr = $theKeyWords[$randnum];
		break;
		case "user":
			$randnum = rand(0,count($userKeyWords)-1);
			$keycodeStr = $userKeyWords[$randnum];
		break;
		default:
			$randnum = rand(0,count($defaultKeyWords)-1);
			$keycodeStr = $defaultKeyWords[$randnum];
	}

	return $keycodeStr;

}

define("THEKEY",matriphe_get_keycode());

function matriphe_keycode() {
	print THEKEY;
}

function matriphe_protection($key) {
	global $keycodeKey;
	print md5($key.$keycodeKey.$key);
}

function matriphe_auto_keycode_form() {

?>
<p>
<input type="hidden" name="perlindungan" value="<?php matriphe_protection(THEKEY); ?>" />
<?php
	global $user_ID;
	if ( $user_ID ) {

?>
<input type="hidden" name="kunciGue" value="<?php matriphe_keycode() ?>" />
</p>
<?php
	} else {
?>
<style>
#kunci {
	border: 1px solid #000;
	font-family: tahoma;
	color: #fff;
	letter-spacing: .4em;
	background: #000;
	width: 20px;
	text-align: center;
	padding: 3px 0px 3px 5px;
}
</style>
<br />
<input  type="text" name="kunciGue" id="kunciGue" tabindex="5" value="" size="9" class="thekey" />
<label for="kunciGue"><small><strong>Code anti-spam</strong> (&agrave; recopier) : </small></label><span id="kunci"><?php matriphe_keycode() ?></span>

</p>
<?php
	}
}

//add_action('comment_form','matriphe_auto_keycode_form');

//-- PROCESSING THE KYECODE

function matriphe_cek_keycode_terkirim($post_ID) {
	global $keycodeKey;
	$keycode_terkirim = trim($_POST['kunciGue']);
	if( md5($keycode_terkirim.$keycodeKey.$keycode_terkirim) != trim($_POST['perlindungan']) ) :
		if (function_exists('fail'))
			fail('Erreur : Veuillez recopier le code de v&eacute;rification anti-spam !');
		else 
			echo 'Erreur : Veuillez recopier le code de v&eacute;rification anti-spam !';
		exit();
	endif;

	return $post_ID;
}

add_action('preprocess_comment', 'matriphe_cek_keycode_terkirim');

?>